//------------------------------------------------------------------------------
//
//  npgdal.h
//
//  ANTz application based on NPE
//
//  Created by Shane Saxon on 3/15/11.
//  Copyright Saxon Digital 2010-2011. All rights reserved.
//
//------------------------------------------------------------------------------
#ifndef NPGDAL_H_
#define NPGDAL_H_


#include <stdio.h>
#include "../../npdata.h"


//------------------------------------------------------------------------------
void npInitGDAL (void* dataRef);
void npCloseGDAL (void* dataRef);

// these functions wrap the standard C file methods on Linux, MSW and OSX
// opens or creates the file in the specified mode "rb+" read/write binary..
FILE* npOpenGDAL (const char* fileName, const char* mode, void* dataRef);

FILE* npGDALNew (const char* fileName, const char* mode, void* dataRef);

FILE* npGDALDialog (const char* fileName, int dialogType, void* dataRef);

// if not saved then opens SaveAs dialog before reseting app
void npGDALClose (void* dataRef);

// wrappers for fread(), fwrite() and rewind()
//void npReadFile (void* writeBuffer, int wordSize, int size, void* dataRef);
int npReadGDAL (void* readBuffer, int elementSize, int elementCount, 
				 FILE* file, void* dataRef);
int npWriteGDAL (const void* str, int wordSize, int size, FILE* file, void* dataRef);

// 
void npSaveGDAL (FILE* file, void* dataRef);

void npImportGDAL (FILE* file, int type, void* dataRef);
void npExportGDAL (FILE* file, void* dataRef);

// file management
void npGetAttribGDAL (int size, void* dataRef);
void npSetAttribGDAL (int size, void* dataRef);

void npTestGDAL (void* fileName, int wordSize, int size, void* dataRef);


#endif